
//these six are libraries, which tells the program borrow code that other people wrote already
#include "sensorsDRV.h"
#include <avr/wdt.h>
#include "TBMotor.h"
#include <Servo.h>
#include <Arduino.h>
#include "oseppRemote.h"
#include <SoftwareSerial.h>
#include <TinyGPS.h>
#include "Wire.h"
#include "HMC5883L.h"
//#include <MemoryFree.h>

//this tells the program that there exists a remote control and which pins on the Arduino power either motor
TinyGPS gps;
OseppRemote remote;
OseppTBMotor Motor1(12, 11);
OseppTBMotor Motor2(8, 3);
//there exists a left motor and a right motor. pins 2 and 4 operate the ultrasonic sensor
#define leftMotor Motor1
#define rightMotor Motor2
Ultrasonic ults(2, 4);
const int servoPin = 9;
const int servoBais = 85;
Servo sv;
int leftSpeed = 0;
int rightSpeed = 0;
float currentLat, currentLong;
float targetLat, targetLong;
int GPS_Course;
unsigned long Distance_To_Home;                                  // variable for storing the distance to destination
HMC5883L compass;                                               // HMC5883L compass(HMC5883L)
int16_t mx, my, mz;                                             // variables to store x,y,z axis from compass (HMC5883L)
int desired_heading;                                            // initialize variable - stores value for the new desired heading
int compass_heading;                                            // initialize variable - stores value calculated from compass readings
int compass_dev = 5;                                            // the amount of deviation that is allowed in the compass heading - Adjust as Needed
                                                                // setting this variable too low will cause the robot to continuously pivot left and right
                                                                // setting this variable too high will cause the robot to veer off course
const float threshold = 300;
int Heading_A;                                                  // variable to store compass heading
int Heading_B;                                                  // variable to store compass heading in Opposite direction
int pass = 0;                                                   // variable to store which pass the robot is on
void setup()
{
  //Setup a watchdog
  //When the battery voltage is insufficient / program unexpected
  //Watchdog reset chip
  Serial.begin(9600);
  Serial3.begin(9600);
 
  pinMode(13, OUTPUT);
  //wdt_enable(WDTO_4S);
  sv.attach(servoPin);
  sv.write(servoBais);
  Wire.begin();                                                 // Join I2C bus used for the HMC5883L compass
  compass.begin();                                              // initialize the compass (HMC5883L)
  compass.setRange(HMC5883L_RANGE_1_3GA);                       // Set measurement range 
  compass.setMeasurementMode(HMC5883L_CONTINOUS);               // Set measurement mode 
  compass.setDataRate(HMC5883L_DATARATE_30HZ);                  // Set data rate 
  compass.setSamples(HMC5883L_SAMPLES_8);                       // Set number of samples averaged 
  compass.setOffset(75,-42);                                        // Set calibration offset

void SetMotor()
{
  if (leftSpeed > 255)leftSpeed = 255; else if (leftSpeed < -255)leftSpeed = -255;
  if (rightSpeed > 255)rightSpeed = 255; else if (rightSpeed < -255)rightSpeed = -255;
  //Depending on your connection,
  //if the direction of the motor rotation is not the direction you want,
  //you can change it by changing the Positive/negative sign of the speed
  leftMotor.SetSpeed(leftSpeed);
  rightMotor.SetSpeed(-rightSpeed);
}
char moreOpenDirection()
{
  long scan[90];
  sv.write(servoBais);
  //Empty array
  for (int i = 0; i < 90; i++)scan[i] = 0;
  delay(255);
  //Scan the distance around and into the array
  for (int i = 0; i > -45; i--)
  {
  sv.write(servoBais + i); delay(2);
  scan[45 - i] = ults.Detect();
  }
  for (int i = -45; i < 45; i++)
  {
  sv.write(i + servoBais); delay(2);
  scan[45 - i - 1] += ults.Detect();
  }
  for (int i = 45; i > 0; i--)
  {
  sv.write(i + servoBais); delay(2);
  scan[45 - i] += ults.Detect();
  }
  //note:Every angle has been scanned for two times.
  sv.write(servoBais);
  //Calculate the side of the more open
  //We can simply sum the distance between two sides.
  long left = 0;
  for (int i = 0; i < 45; i++)left += scan[i];
  long right = 0;
  for (int i = 45; i < 90; i++)right += scan[i];
  if (left > right)return 'L'; else return 'R';
}
const int controlMode_Button = 0;
const int controlMode_Joystick = 1;
const int controlMode_Gravity = 2;
int controlMode = controlMode_Button;
float dist_filter()
{
  float avgDist = 0;
  int i = 0;
  for (i = 0; i < 10; i++)avgDist += ults.Detect();
  return avgDist / i;
}

void processGPS() {
  while (Serial3.available() > 0) {
  if (gps.encode(Serial3.read()))
  {
    gps.f_get_position(&currentLat, &currentLong); ////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /* Serial.print("LAT: ");
    Serial.println(currentLatitude, 6);
    
    Serial.print("LNG: ");
    Serial.println(currentLongitude, 6);
    delay(3000); //send latitude and longitude every 3 seconds, maybe delete if this is a problem ******
    */
  }
  }
}
void distanceToWaypoint() //this returned an integer and I changed it to void
{
  float delta = radians(currentLong - targetLong);
  float sdlong = sin(delta);
  float cdlong = cos(delta);
  float lat1 = radians(currentLat);
  float lat2 = radians(targetLat);
  float slat1 = sin(lat1);
  float clat1 = cos(lat1);
  float slat2 = sin(lat2);
  float clat2 = cos(lat2);
  delta = (clat1 * slat2) - (slat1 * clat2 * cdlong);
  delta = sq(delta);
  delta += sq(clat2 * sdlong);
  delta = sqrt(delta);
  float denom = (slat1 * slat2) + (clat1 * clat2 * cdlong);
  delta = atan2(delta, denom);
  Distance_To_Home =  delta * 6372795;
  /*
  // check to see if we have reached the current waypoint
  if (Distance_to_Home <= WAYPOINT_DIST_TOLERANE-1)
  {
  move_forward();
  } */
  //return Distance_To_Home;
}
void courseToWaypoint() //this returned an int and I changed it to void
{
  float dlon = radians(targetLong - currentLong);
  float cLat = radians(currentLat);
  float tLat = radians(targetLat);
  float a1 = sin(dlon) * cos(tLat);
  float a2 = sin(cLat) * cos(tLat) * cos(dlon);
  a2 = cos(cLat) * sin(tLat) - a2;
  a2 = atan2(a1, a2);
  if (a2 < 0.0)
  {
  a2 += TWO_PI;
  }
  GPS_Course = degrees(a2);
  //return GPS_Course;
}
void getCompass()                                             // get latest compass value
 { 
  Vector norm = compass.readNormalize();
  // Calculate heading
  float heading = atan2(norm.YAxis, norm.XAxis);
 
  if(heading < 0)
  heading += 2 * M_PI;    
  compass_heading = (int)(heading * 180/M_PI);                // assign compass calculation to variable (compass_heading) and convert to integer to remove decimal places                                                           
 }
 void move_forward() {
if (dist_filter() < threshold) //this checks if there's an object
  {
  //If an obstacle is detected
  //stop the car first
  leftSpeed = 0;
  rightSpeed = 0;
  SetMotor();
  if (moreOpenDirection() == 'R')
  {
    //If the right side is more open, turn right.
    leftSpeed = 255;
    rightSpeed = -255;
  } else {
    leftSpeed = -255;
    rightSpeed = 255;
  }
  SetMotor();
  //Keep turning until you avoid it
  while (dist_filter() < threshold) delay(50);
  //The obstacle is not in the range of ultrasonic sensor
  //It's probably still on the Tank route
  //Continue to turn out for some time, may be able to completely avoid it
  //Time delay depends on the speed of the tank.
  delay(300);
  return;//to the beginning of the loop function.
  }
  //If there is no problem, keep moving forward.
  leftSpeed = 255;
  rightSpeed = 255;
  SetMotor();
}
int tick = 0;
void navigation() {
  while (true) {  
                                                              
  getCompass();                                               // Update Compass heading
  Serial.print("Heading: ");
  Serial.println(compass_heading, 6);       
                              
  processGPS();
  Serial.print("LAT= ");
  Serial.println(currentLat, 6);
  Serial.print("LNG= ");
  Serial.println(currentLong, 6);
 
  distanceToWaypoint();
  Serial.print("Dist: ");
  Serial.println(Distance_To_Home, 6);
 
  courseToWaypoint();                                         // Tiny GPS function that retrieves GPS data - update GPS location// delay time changed from 100 to 10 
  Serial.print("Course:");
  Serial.println(GPS_Course, 6);
 
  if (Distance_To_Home == 0)                                // If the Vehicle has reached it's Destination, then Stop
      {
      leftSpeed = 0; rightSpeed = 0;
      SetMotor();                                           // Stop the robot after each waypoint is reached
      Serial.println("Arrived!");                           // Print to Bluetooth device - "You have arrived"       
      break;                                                // Break from Go_Home procedure and send control back to the Void Loop
                                                              // go to next waypoint
      
      }  
   Serial.println("Checked if home");
  
   if ( abs(GPS_Course - compass_heading) <= 15)                // If GPS Course and the Compass Heading are within x degrees of each other then go Forward                                                               
                                                                // otherwise find the shortest turn radius and turn left or right 
    {
      move_forward();                                             // Go Forward
      Serial.println("Moving forward");
    } else
      {  
        Serial.println("Calculating turn");                                                 
          int x = (GPS_Course - 360);                         // x = the GPS desired heading - 360
          int y = (compass_heading - (x));                    // y = the Compass heading - x
          int z = (y - 360);                                  // z = y - 360
          
          if ((z <= 180) && (z >= 0))                         // if z is less than 180 and not a negative value then turn left otherwise turn right
                { leftSpeed = 160;
                  rightSpeed = -160;
                  SetMotor();
                  Serial.println("Turning left");
                  }
          else { leftSpeed = -160;
                  rightSpeed = 160;
                  SetMotor();
                  Serial.println("Turning right");
                  }             
      }
  tick = tick + 1;
  Serial.print(tick);
  Serial.println(" loop(s)");
  delay(1);
  //Serial.println(freeMemory());
  }                                                           // End of While Loop
 
}

void loop() {
  // put your main code here, to run repeatedly:
  delay(40);//oseppRemote send data per 40ms
  //show latitude and longitude on the controller
 
  processGPS();
 
  while (Serial.available() > 0)remote.feed(Serial.read());
  if (remote.isTimeoutFor(200)) {
  leftSpeed = 0; rightSpeed = 0;
  SetMotor();
  return;
  }
  if (remote.getButtonState(BUTTON_A)) {
  
   targetLat = currentLat;
   targetLong = currentLong;
   Serial.println("Saved at ");
   Serial.print("LAT: ");
   Serial.println(targetLat, 6);
   Serial.print("LNG: ");
   Serial.println(targetLong, 6);
 
  } else if (remote.getButtonState(BUTTON_B)) {
  //while (true) {
  navigation(); /*
  if (Distance_To_Home == 0)                                // If the Vehicle has reached it's Destination, then Stop
      {
      leftSpeed = 0; rightSpeed = 0;
      SetMotor();                                           // Stop the robot after each waypoint is reached
      Serial.println("Arrived!");                           // Print to Bluetooth device - "You have arrived"       
      break;                                                // Break from Go_Home procedure and send control back to the Void Loop
  } */
  } else if (remote.getButtonState(BUTTON_X)) {
  
  } else if (remote.getButtonState(BUTTON_Y)) {
  
  }
 
  //If in 4 seconds,The program is not coming back here.
  //Chip will reset
  //wdt_reset();
  sv.write(servoBais);
  if (controlMode == controlMode_Button) {
  if (remote.getButtonState(BUTTON_U)) {
    move_forward();
  }
  else if (remote.getButtonState(BUTTON_D)) {
    leftSpeed = -255;
    rightSpeed = -255;
    SetMotor();
  } else if (remote.getButtonState(BUTTON_L)) {
    leftSpeed = 255;
    rightSpeed = -255;
    SetMotor();
 
  } else if (remote.getButtonState(BUTTON_R)) {
    leftSpeed = -255;
    rightSpeed = 255;
    SetMotor();
 
  } else {
    leftSpeed = 0;
    rightSpeed = 0;
    SetMotor();
  }
  }
}




